package ActiveState::SpamEngine::Hash::PerlHash;

sub new {
    my ($cls,$hash,$readonly) = @_;
    $readonly ||= 1;
    $hash ||= {};
    my $self = {
        readonly=>$readonly,
        hash=>$hash,
    };
    bless $self, $cls;
    return $self;
}

sub get {
    my($self,$key) = @_;
    # Return status code to hash_get() in pmx_engine.c
    $_[2] = exists $self->{hash}{$key} if @_ > 2;
    return $self->{hash}{$key}
}

sub set {
    my($self,$key,$value) = @_;
    if ($self->{readonly}) {
        $_[3] = 0 if @_ > 3;
        return 0;
    }
    $_[3] = 1 if @_ > 3;
    $self->{hash}{$key} = $value;
    return 1;
}

sub del {
    my($self,$key) = @_;
    if ($self->{readonly}) {
        $_[2] = 0 if @_ > 2;
        return 0;
    }
    my $temp = exists $self->{hash}{$key};
    $_[2] = $temp if @_ > 2;
    delete $self->{hash}{$key} if $temp;
    return $temp;
}

sub save {
}

sub enumerate {
    my($self,$cb,$data) = @_;
    return scalar keys %{$self->{hash}} unless defined $cb;

    my $count = 0;
    for my $key (keys %{$self->{hash}}) {
        ++$count;
        if (ref($cb) eq 'CODE') {
            $cb->($data, $key, $self->{hash}{$key}) or last;
        }
        else {
            hash_cb($cb, $data, $key, $self->{hash}{$key}) or last;
        }
    }

    return $count;
}
1;
