package ActiveState::SpamEngine::Plugin::fur;

# Anti-spam engine FUR pluring

use strict;
use warnings;

use base qw(ActiveState::SpamEngine::Plugin);

use ActiveState::SpamEngine qw(PMX_TYPE_INTEGER _get1);

our @SP_REQUIRE = qw(net part);
our $SP_ATTRIBUTE = [
    'skip-rbl-checks', PMX_TYPE_INTEGER, undef,
];

sub plugin {
    my ($engine, $plugin) = @_;
    for my $dep (@SP_REQUIRE) { $engine->load_plugin($dep); }
    $engine->declare_attributes($SP_ATTRIBUTE, $plugin);
    $engine->subscribe($plugin, 'core.compile', \&compile);
}

sub compile {
    my ($engine) = @_;

    # FIXME - stop here if skip-rbl-checks set?  ..or let it skip within the Sophos::SXL object.

    $engine->subscribe('fur', 'part.fur_ip', \&fur_ip);
    $engine->initialised('fur');
}

sub sxl_hit {
    my ($x, $query, $result) = @_;
    my ($engine, $xtra) = @$x;
    $engine->addfeature($xtra, $result, $query);
}

sub fur_ip {
    my ($engine, $extra, $fur_ip) = @_;

    my $sxl = $engine->sxl('fur');
    if($fur_ip) {
        $engine->log('DEBUG', "FUR_IP: $fur_ip");
        my $yaler = join('.', reverse split /\./, $fur_ip);
        $sxl->get($yaler, \&sxl_hit, [$engine, $extra]);
    }
}

1;
