package ActiveState::SpamEngine::Plugin::rip;

#Second And Subsequent Untrusted Relays

use strict;
use warnings;

use base qw(ActiveState::SpamEngine::Plugin);

use ActiveState::SpamEngine qw(PMX_TYPE_INTEGER _get1);

our @SP_REQUIRE = qw(net part);
our $SP_ATTRIBUTE = [
    'skip-rbl-checks', PMX_TYPE_INTEGER, undef,
];

sub plugin {
    my ($engine, $plugin) = @_;
    for my $dep (@SP_REQUIRE) { $engine->load_plugin($dep); }
    $engine->declare_attributes($SP_ATTRIBUTE, $plugin);
    $engine->subscribe($plugin, 'core.compile', \&compile);
}

sub compile {
    my ($engine) = @_;

    # FIXME - stop here if skip-rbl-checks set?  ..or let it skip within the Sophos::SXL object.

    $engine->subscribe('rip', 'net.rip', \&rip);
    $engine->initialised('rip');
}

sub sxl_hit {
    my ($x, $query, $result) = @_;
    my ($engine, $xtra) = @$x;
    $engine->addfeature($xtra, $result, $query);
}

sub rip {
    my ($engine, $extra, $rip) = @_;

    my $sxl = $engine->sxl('rip');
    my $index = 2;
    for my $ip (@$rip) {
        $engine->log('DEBUG', "Untrusted relay \#$index: $ip");
        ++$index;
        my $yaler = join('.', reverse split /\./, $ip);
        $sxl->get($yaler, \&sxl_hit, [$engine, $extra]);
    }
}

1;
